> This page is for Afterpay Online Developer, version Main (default).
> For other versions, use one of these documentation indexes:
> - Main (default): https://developers.afterpay.com/afterpay-online-developer/main/llms.txt
> - v1: https://developers.afterpay.com/afterpay-online-developer/v-1/llms.txt
> - Chinese: https://developers.afterpay.com/afterpay-online-developer/chinese/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.afterpay.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.afterpay.com/_mcp/server.

# Update Payment by Order ID

PUT https://global-api-sandbox.afterpay.com/v2/payments/{orderId}
Content-Type: application/json

This endpoint is to create merchant side order ID's following the Afterpay order ID creation. The endpoint should be called immediately after the Afterpay order is created.

Reference: https://developers.afterpay.com/afterpay-online-developer/api-reference/reference/payments/update-payment-by-order-id

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Servers

- `https://global-api-sandbox.afterpay.com` (Sandbox, default)
- `https://global-api.afterpay.com` (Production)

## Request

### Path parameters

- `orderId` (string, required) — The Order ID to update

### Headers

- `Accept` (string, optional, default: application/json)

### Body (application/json)

This endpoint expects an object.

- `merchantReference` (string, required, default: new_merchant_order_id_1234) — The merchant’s new order id to replace with

## Response

### 201

Returns object containing the following attributes.

- `id` (string, optional) — The unique Afterpay (merchant payment) payment Id
- `token` (string, optional) — Checkout token to be used to complete consumer checkout and payment.
- `status` (string, optional) — \"APPROVED" (update is only valid for successful orders)
- `created` (any, optional) — The payment creation time (ISO 8601 UTC/Zulu time).
- `originalAmount` (V2PaymentsOrderIdPutResponsesContentApplicationJsonSchemaOriginalAmount, optional) — Total amount for the order. See Money.
- `openToCaptureAmount` (V2PaymentsOrderIdPutResponsesContentApplicationJsonSchemaOpenToCaptureAmount, optional) — Total amount that can be captured for order. See Money.
- `paymentState` (string, optional) — Available states: "AUTH_APPROVED", "CAPTURED", "VOIDED", "EXPIRED", "AUTH_DECLINED", "PARTIALLY_CAPTURED", "CAPTURE_DECLINED""
- `merchantReference` (any, optional)
- `refunds` (V2PaymentsOrderIdPutResponsesContentApplicationJsonSchemaRefunds, optional) — The refund details for merchant's order. See Refund.
- `orderDetails` (V2PaymentsOrderIdPutResponsesContentApplicationJsonSchemaOrderDetails, optional) — The order bound to the payment. See Order Details.
- `events` (V2PaymentsOrderIdPutResponsesContentApplicationJsonSchemaEvents, optional) — Event list for for merchant's order. See Events.

## Errors

### 404 Not Found Error

The Afterpay payment Id to update was not found. Error code `not_found`.

- `any`

## Types

### V2PaymentsOrderIdPutResponsesContentApplicationJsonSchemaOriginalAmount

Total amount for the order. See Money.

### V2PaymentsOrderIdPutResponsesContentApplicationJsonSchemaOpenToCaptureAmount

Total amount that can be captured for order. See Money.

### V2PaymentsOrderIdPutResponsesContentApplicationJsonSchemaRefunds

The refund details for merchant's order. See Refund.

### V2PaymentsOrderIdPutResponsesContentApplicationJsonSchemaOrderDetails

The order bound to the payment. See Order Details.

### V2PaymentsOrderIdPutResponsesContentApplicationJsonSchemaEvents

Event list for for merchant's order. See Events.

## Examples

**Request**

```json
{
  "merchantReference": "ORD-20240615-98765"
}
```

**Response**

```json
{
  "id": "APY1234567890",
  "token": "chk_4a5f6b7c8d9e0f1a2b3c4d5e6f7g8h9i",
  "status": "APPROVED",
  "created": null,
  "originalAmount": {},
  "openToCaptureAmount": {},
  "paymentState": "AUTH_APPROVED",
  "merchantReference": null,
  "refunds": {},
  "orderDetails": {},
  "events": {}
}
```

**SDK Code**

```python
import requests

url = "https://global-api-sandbox.afterpay.com/v2/payments/orderId"

payload = { "merchantReference": "ORD-20240615-98765" }
headers = {
    "User-Agent": "User-Agent"
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers, auth=("<username>", "<password>"))

print(response.json())
```

```javascript
const url = 'https://global-api-sandbox.afterpay.com/v2/payments/orderId';
const credentials = btoa("<username>:<password>");

const options = {
  method: 'PUT',
  headers: {
    'User-Agent': 'User-Agent',
    Authorization: `Basic ${credentials}`,
    'Content-Type': 'application/json'
  },
  body: '{"merchantReference":"ORD-20240615-98765"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://global-api-sandbox.afterpay.com/v2/payments/orderId"

	payload := strings.NewReader("{\n  \"merchantReference\": \"ORD-20240615-98765\"\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("User-Agent", "User-Agent")
	req.SetBasicAuth("<username>", "<password>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://global-api-sandbox.afterpay.com/v2/payments/orderId")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["User-Agent"] = 'User-Agent'
request.basic_auth("<username>", "<password>")
request["Content-Type"] = 'application/json'
request.body = "{\n  \"merchantReference\": \"ORD-20240615-98765\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://global-api-sandbox.afterpay.com/v2/payments/orderId")
  .header("User-Agent", "User-Agent")
  .basicAuth("<username>", "<password>")
  .header("Content-Type", "application/json")
  .body("{\n  \"merchantReference\": \"ORD-20240615-98765\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://global-api-sandbox.afterpay.com/v2/payments/orderId', [
  'body' => '{
  "merchantReference": "ORD-20240615-98765"
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'User-Agent' => 'User-Agent',
  ],
    'auth' => ['<username>', '<password>'],
]);

echo $response->getBody();
```

```csharp
using RestSharp;
using RestSharp.Authenticators;

var client = new RestClient("https://global-api-sandbox.afterpay.com/v2/payments/orderId");
client.Authenticator = new HttpBasicAuthenticator("<username>", "<password>");
var request = new RestRequest(Method.PUT);
request.AddHeader("User-Agent", "User-Agent");

request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"merchantReference\": \"ORD-20240615-98765\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let credentials = Data("<username>:<password>".utf8).base64EncodedString()

let headers = [
  "User-Agent": "User-Agent",
  "Authorization": "Basic \(credentials)",
  "Content-Type": "application/json"
]
let parameters = ["merchantReference": "ORD-20240615-98765"] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://global-api-sandbox.afterpay.com/v2/payments/orderId")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```